
#include "gens4all.h"
#include "vdp_rend.h"
#include "blit.h"

#ifndef U32
	#define U32 unsigned int
#endif

#ifndef DREAMCAST
void Blit_X1(unsigned char *Dest, const int pitch, const int x, const int y, const int offset)
{
	int i;
	register U32 *s = (U32 *) MD_Screen + 4;
	register U32 *d = (U32 *)Dest;
	const U32 nx = (x >> 4);
	const U32 soff = (offset/4);
	const U32 doff = (pitch - x*2)/4;

	for (i = 0; i < y; i++)
	{
		register int n=nx;
		while(n--)
		{
			*d++ = *s++;
			*d++ = *s++;
			*d++ = *s++;
			*d++ = *s++;
			*d++ = *s++;
			*d++ = *s++;
			*d++ = *s++;
			*d++ = *s++;
		}
		s += soff;
		d += doff;
	}
}

void Blit_Scale2x (unsigned char *Dest, int pitch, int x, int y, int offset) 
{
	int i, j;
	int B, D, E, F, H;
	int E0, E1, E2, E3;
  
    // A B C
    // D E F
    // G H I
  
	int ScrWdth, ScrAdd;
	int SrcOffs, DstOffs;

	ScrAdd = offset >> 1;
	ScrWdth = x + ScrAdd;
	SrcOffs = 8;
	DstOffs = 0;
  
	for (i = 0; i < y; i++)
    {
		E = MD_Screen[SrcOffs - 1];
		F = MD_Screen[SrcOffs];
		DstOffs = i * pitch * 2;
		
		for (j = 0; j < x; j++)
		{
			D = E;
			E = F;
			B = MD_Screen[SrcOffs - ScrWdth];
			H = MD_Screen[SrcOffs + ScrWdth];
			F = MD_Screen[++SrcOffs];
			E0 = D == B && B != F && D != H ? D : E;
			E1 = B == F && B != D && F != H ? F : E;
			E2 = D == H && D != B && H != F ? D : E;
			E3 = H == F && D != H && B != F ? F : E;
	  
			// E0
			Dest[DstOffs] = E0;
			Dest[DstOffs + 1] = E0 >> 8;
	  
			// E1
			Dest[DstOffs + 2] = E1;
			Dest[DstOffs + 3] = E1 >> 8;
	  
			// E2
			Dest[DstOffs + pitch] = E2;
			Dest[DstOffs + pitch + 1] = E2 >> 8;
	  
			// E3
			Dest[DstOffs + pitch + 2] = E3;
			Dest[DstOffs + pitch + 3] = E3 >> 8;

			DstOffs += 4;
		}     

		SrcOffs += ScrAdd;
	}
}


#else

void Blit_Dreamcast(unsigned char *Dest, const int x, const int y, const int offset)
{
	int i;

	register U32 *s = (U32 *) MD_Screen + 4;
	register U32 *d = (U32 *)(void *) (0xe0000000 | (((unsigned long)Dest) & 0x03ffffe0));
	const U32 nx = (x >> 4);
	const U32 soff = (offset/4);
	const U32 doff = (640 - x*2)/4;

	QACR0 = ((((unsigned int)Dest)>>26)<<2)&0x1c;
	QACR1 = ((((unsigned int)Dest)>>26)<<2)&0x1c;

	for(i=0;i<y;i++)
	{
		register int n=nx;
		while(n--)
		{
			asm("pref @%0" : : "r" (s + 8));
			d[0] = *(s++);
			d[1] = *(s++);
			d[2] = *(s++);
			d[3] = *(s++);
			d[4] = *(s++);
			d[5] = *(s++);
			d[6] = *(s++);
			d[7] = *(s++);
			asm("pref @%0" : : "r" (d));
			d += 8;
		}
		s+=soff;
		d+=doff;
	}
	d = (unsigned int *)0xe0000000;
	d[0] = d[8] = 0;
}
#endif
